Subject: Re: [PATCHv2 0/4] git-p4: small fixes to branches and labels; tests

From: Pete Wyckoff <[email-masked]>
Date: Wed, 30 Nov 2011 23:02:59 -0500

[email-masked] wrote on Thu, 01 Dec 2011 00:33 +0000:
> On Wed, Nov 30, 2011 at 10:58 PM, Pete Wyckoff <[email-masked]> wrote:
> > This is another fundamental disconnect between p4 and git.
> > Reading
> >
> > http://www.perforce.com/perforce/doc.current/manuals/p4guide/07_labels.html
> >
> > it is clear that labels are supposed to be used exactly where
> > tags cannot:  to specify a collection of files as they existed
> > at _different_ points in the commit history.
> 
> Check the "Use Tag Fixup Branches" section in fast-import manual, it
> might help on this. The basic concept is to create a special branch
> that puts all files in the same state the P4 label would put them and
> then tag it in git.
> 
> Tried to use this for my branch stuff, but with no success.

Interesting, thanks.  One could certainly construct any arbitrary
tree to represent the tag.  But it would be a truly evil merge of
possibly many commits.

> > Thus I think supporting labels is kind of pointless.  But in the
> > restricted use case that perforce docs tell us not to do, namely
> > using labels to identify change numbers, git can reflect that
> > with tags.
> 
> I still use labels as simple tags. Telling that we should use
> changelists instead of labels is the same as saying that we should use
> IP addresses instead of host names. It works, but I doubt you will
> ever remember it unless you write it down somewhere.

I see your point.  P4 labels are the only way that they support
tagging, apparently.  I'm okay with leaving label support in
git-p4.  And it will be nice if Luke makes it behave a bit
better.  But doing heroics to emulate cross-commit tags feels
like a lot of work, and the wrong direction.

		-- Pete